package org.bitbucket.bradleysmithllc.etlunit.io.file;

import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public interface DataFile
{
	interface FileData
	{
		Iterator<FileRow> iterator() throws IOException;

		void dispose() throws IOException;
	}

	interface FileRow
	{
		Map<String, String> getData();

		OrderKey getOrderKey();
	}

	interface DataConverter
	{
		String format(Object data, DataFileSchema.Column column);
	}

	File getSource();

	DataFileWriter getWriter() throws IOException;

	DataFileWriter getWriter(DataConverter converter) throws IOException;

	Map<String, Map<String, String>> getIndex();

	FileData getFileData() throws IOException;

	FileData getFileData(List<String> columns) throws IOException;

	DataFileSchema getDataFileSchema();
}